#include "cs.h"                 /*                      ENTRY.C         */
#include "insert.h"
#include "clarinet.h"
#include "flute.h"
#include "bowed.h"
#include "bowedbar.h"
#include "marimba.h"
#include "brass.h"
#include "vibraphn.h"
#include "shaker.h"
#include "phisem.h"
#include "fm4op.h"
#include "moog1.h"
#include "singwave.h"
#include "mandolin.h"
#include "midiops.h"
#include "dcblockr.h"
#include "flanger.h"
#include "lowpassr.h"
#if defined(CWIN) || defined(TCLTK)
#include "control.h"
#endif
#include "schedule.h"
#include "cwindow.h"
#include "spectra.h"
#include "pitch.h"
#include "scansyn.h"
#include "scansynx.h"
#include "vbap.h"
#include "uggab.h"
#include "repluck.h"
#include "aops.h"
#include "ugens1.h"
#include "nlfilt.h"
#include "fhtfun.h"
#include "vdelay.h"
#include "ugens2.h"
#include "babo.h"
#include "ugmoss.h"
#include "bbcut.h"
#include "spat3d.h"
#include "pstream.h"
#include "oscbnk.h"
#include "oscils.h"
#include "wave-terrain.h"
#include "clfilt.h"
#include "midiinterop.h"
#include "ftgen.h"
#if defined(HAVE_FLTK)
#include "widgets.h"                    /* IV - Aug 23 2002 */
#endif
#include "fout.h"
#include "ugrw1.h"

#define S       sizeof

#if defined(CWIN) || defined(TCLTK)
void    cntrl_set(void*), control(void*), ocontrol(void*);
void    button_set(void*), button(void*), check_set(void*), check(void*);
void    textflash(void*);
#endif
void    varicolset(void*), varicol(void*);
void    pinkset(void*), pinkish(void*), inh(void*), ino(void*), in16(void*);
void    in32(void*), inall(void*), zaset(void*), inz(void*), outh(void*);
void    outo(void*), outx(void*), outX(void*), outch(void*), outall(void*);
void    zaset(void*), outz(void*), cpsxpch(void*), cps2pch(void*);
void    cpstun(void*),cpstun_i(void*);
void    nlfiltset(void*), nlfilt(void*), Xsynthset(void*), Xsynth(void*);
void    wgpsetin(void*), wgpluck(void*), wgpset(void*), wgpluck(void*);
void    clarinset(void*), clarin(void*), fluteset(void*), flute(void*);
void    bowedset(void*), bowed(void*), bowedbarset(void*), bowedbar(void*);
void    brassset(void*), brass(void*), marimbaset(void*), marimba(void*);
void    vibraphnset(void*), vibraphn(void*), agogobelset(void*), agogobel(void*);
void    shakerset(void*), shaker(void*), cabasaset(void*), cabasa(void*);
void    crunchset(void*), cabasa(void*), sekereset(void*), sekere(void*);
void    sandset(void*), sekere(void*), stixset(void*), sekere(void*);
void    guiroset(void*), guiro(void*), tambourset(void*), tambourine(void*);
void    bambooset(void*), bamboo(void*), wuterset(void*), wuter(void*);
void    sleighset(void*), sleighbells(void*), tubebellset(void*), tubebell(void*);
void    rhodeset(void*), tubebell(void*), wurleyset(void*), wurley(void*);
void    heavymetset(void*), heavymet(void*), b3set(void*), hammondB3(void*);
void    FMVoiceset(void*), FMVoice(void*), percfluteset(void*), percflute(void*);
void    Moog1set(void*), Moog1(void*), voicformset(void*), voicform(void*);
void    mandolinset(void*), mandolin(void*), dcblockrset(void*), dcblockr(void*);
void    flanger_set(void*), flanger(void*), sum(void*), product(void*);
void    macset(void*), maca(void*), macset(void*), mac(void*), instcount(void*);
void    adsrset(void*), klnseg(void*), linseg(void*), madsrset(void*);
void    klnsegr(void*), linsegr(void*), xdsrset(void*), kxpseg(void*);
void    expseg(void*), mxdsrset(void*), kxpsegr(void*), expsegr(void*);
void    schedule(void*), schedwatch(void*), ifschedule(void*), kschedule(void*);
void    triginset(void*), ktriginstr(void*), trigseq_set(void*), trigseq(void*);
void    event_set(void*), eventOpcode(void*);
void    seqtim_set(void*), seqtim(void*), lfoset(void*), lfok(void*);
void    lfoa(void*), stresonset(void*), streson(void*), pitchset(void*);
void    pitch(void*), clockset(void*), clockon(void*), clockset(void*);
void    clockoff(void*), clockread(void*), impulse_set(void*), impulse(void*);
void    mute_inst(void*);
void    pitchamdfset(void*), pitchamdf(void*), scsnu_init(void*);
void    scsnu_play(void*), scsnsmapx(void*);
void    scsnux_init(void*),scsnux(void*),scsnsx_init(void*),scsnsx(void*);
void    scsns_init(void*), scsns_play(void*), scsnmapx_init(void*);
void    scsnmapx(void*), clip_set(void*), clip(void*);
void    vbap_FOUR_init(void*), vbap_FOUR (void*), vbap_EIGHT_init(void*);
void    vbap_EIGHT(void*), vbap_SIXTEEN_init(void*), vbap_SIXTEEN(void*);
void    vbap_zak_init(void*), vbap_zak(void*), vbap_ls_init(void*);
void    vbap_FOUR_moving_init(void*), vbap_FOUR_moving(void*);
void    vbap_EIGHT_moving_init(void*), vbap_EIGHT_moving(void*);
void    vbap_SIXTEEN_moving_init(void*), vbap_SIXTEEN_moving(void*);
void    vbap_zak_moving_init(void*), vbap_zak_moving(void*), ksense(void*);
void    isense(void*), reverbx_set(void*), reverbx(void*);
#ifdef BETA
void    Foscset(void*), Fosckk(void*), Foscka(void*);
void    Foscak(void*), Foscaa(void*), p_s(void*);
#endif
void    trnset(void*), ktrnseg(void*), trnseg(void*);
void    lpf18set(void*), lpf18db(void*);
void    wavesetset(void*), waveset(void*);
void    dconvset(void *), dconv(void *);
void    vcombset(void *), vcomb(void *), valpass(void *);
void    ftmorfset(void *), ftmorf(void *);
void    pfun(void*);
void    BBCutMonoInit(void *), BBCutMono(void *), BBCutStereoInit(void *);
void    BBCutStereo(void *);
void    spat3dset(void*), spat3d(void*), spat3diset(void*), spat3di(void*);
void    spat3dt(void*);
void    pvsanalset(void *),pvsanal(void *),pvsynthset(void*),pvsynth(void *);
void    pvadsynset(void *), pvadsyn(void *);
void    pvscrosset(void *),pvscross(void *);
void    pvsfreadset(void *), pvsfread(void *);
void    pvsmaskaset(void *),pvsmaska(void *);
void    pvsftwset(void *),pvsftw(void *),pvsftrset(void *),pvsftr(void *);
void    pvsinfo(void *), gettempo(void*);
void    fassign(void *);
void    loopseg_set(void*), loopseg(void*), lpshold(void*);
void    lineto_set(void*), lineto(void*), tlineto_set(void*),tlineto(void*);
void    vibrato_set(void*), vibrato(void*),vibr_set(void*), vibr(void*);
void    jitter2_set(void*), jitter2(void*),jitter_set(void*), jitter(void*);
void    jitters_set(void*), jitters(void*), jittersa(void*);
void    oscbnkset(void*), oscbnk(void*), userrnd_set(void*);
void    oscktset(void*), kosclikt(void*), osckkikt(void*), osckaikt(void*);
void    oscakikt(void*), oscaaikt(void*), oscktpset(void*), oscktp(void*);
void    oscktsset(void*), osckts(void*);
void    iDiscreteUserRand(void*), kDiscreteUserRand(void*), Cuserrnd_set(void*);
void    aDiscreteUserRand(void*), iContinuousUserRand(void*);
void    kContinuousUserRand(void*), aContinuousUserRand(void*);
void    ikRangeRand(void*), aRangeRand(void*);
void    randomi_set(void*), krandomi(void*), randomi(void*);
void    randomh_set(void*), krandomh(void*), randomh(void*);
void    random3_set(void*), random3(void*),random3a(void*);
void    ipowoftwo(void *), ilogbasetwo(void *), db(void*);
void    powoftwo_set(void *), powoftwoa(void *), dbi(void*), dba(void*);
void    powoftwo(void *), powoftwoa(void *), semitone(void*), isemitone(void*);
void    asemitone(void*), cent(void*), icent(void*), acent(void*);
void    grain2set(void*), grain2(void*), grain3set(void*), grain3(void*);
void    rnd31set(void*), rnd31i(void*), rnd31k(void*), rnd31a(void*);
void    vco2init(void*), vco2ftset(void*), vco2ft(void*);
void    vco2set(void*), vco2(void*);
void    and_kk(void*), and_ka(void*), and_ak(void*), and_aa(void*);
void    or_kk(void*), or_ka(void*), or_ak(void*), or_aa(void*);
void    xor_kk(void*), xor_ka(void*), xor_ak(void*), xor_aa(void*);
void    not_k(void*), not_a(void*);
void    midichn(void*), pgmassign(void*), wtinit(void*), wtPerf(void*);
void    scantinit(void*), scantPerf(void*), scanhinit(void*);
void    clfiltset(void*), clfilt(void*);
void    midinoteoff(void*), midinoteonkey(void*), midinoteoncps(void*);
void    midinoteonoct(void*), midinoteonpch(void*), midipolyaftertouch(void*);
void    midicontrolchange(void*), midiprogramchange(void*);
void    midichannelaftertouch(void*), midipitchbend(void*), mididefault(void*);
#if defined(HAVE_FLTK)                  /* IV - Aug 23 2002 */
void    fl_slider(void*), fl_slider_bank(void*);
void    StartPanel(void*), EndPanel(void*), FL_run(void*);
void    fl_widget_color(void*), fl_widget_color2(void*);
void    fl_knob(void*), fl_roller(void*), fl_text(void*);
void    fl_value(void*), StartScroll(void*), EndScroll(void*);
void    StartPack(void*), EndPack(void*), fl_widget_label(void*);
void    fl_setWidgetValuei(void*);                      /* IV - Jan 08 2003 */
void    fl_setWidgetValue_set(void*), fl_setWidgetValue(void*);
void    fl_update(void*), StartGroup(void*), EndGroup(void*);
void    StartTabs(void*), EndTabs(void*);
void    fl_joystick(void*), fl_button(void*), FLkeyb(void*), fl_counter(void*);
void    set_snap(void*), get_snap(void*);
void    fl_setColor1(void*), fl_setColor2(void*);
void    fl_setTextSize(void*), fl_setTextColor(void*);
void    fl_setFont(void*), fl_setText(void*), fl_setSize(void*);
void    fl_setTextType(void*), fl_setBox(void*);
void    fl_setPosition(void*), fl_hide(void*), fl_show(void*), fl_box(void*);
void    fl_align(void*);
void    save_snap(void*), load_snap(void*), fl_button_bank(void*);
void    FLprintkset(void*), FLprintk(void*);
void    FLprintk2set(void*), FLprintk2(void*);
#endif
void    invalset(void*), kinval(void*), outvalset(void*), koutval(void*);
void    subinstrinitset(void*);                 /* IV - Dec 20 2002 */
void    subins2_set(void*), subinstrset(void*), subinstr(void*);
void    useropcdset(void*), useropcd(void*), setksmpsset(void*);
void    xinset(void*), xoutset(void*);          /* IV - Sep 10 2002 */
void    ingoto(void*), kngoto(void*);
void    nstrnumset(void*);
void    ftsave(void*), ftload(void*), ftsave_k_set(void*), ftsave_k(void*);
void    ftsave_k_set(void*), ftload_k(void*);
/* IV - Dec 20 2002 */
void    addkk(void*), subkk(void*), mulkk(void*), divkk(void*);
void    addka(void*), subka(void*), mulka(void*), divka(void*);
void    addak(void*), subak(void*), mulak(void*), divak(void*);
void    addaa(void*), subaa(void*), mulaa(void*), divaa(void*);
void    inc_k(void*), inc_a(void*), dec_k(void*), dec_a(void*);
void    shl_k(void*), shl_a(void*), sqr_k(void*), sqr_a(void*);
void    vincr_kk(void*), vincr_ka(void*), vincr_ak(void*), vincr_aa(void*);
void    vdecr_kk(void*), vdecr_ka(void*), vdecr_ak(void*), vdecr_aa(void*);
void    vmul_kk(void*), vmul_ka(void*), vmul_ak(void*), vmul_aa(void*);
void    vdiv_kk(void*), vdiv_ka(void*), vdiv_ak(void*), vdiv_aa(void*);
/* IV - Dec 20 2002: new opcodes from Matt J. Ingalls */
void    sprintksset(void*), sprintks(void*), printsset(void*);
void    fprintf_set(void*), fprintf_i(void*), fprintf_k(void*);
/* IV - Jan 02 2003: these opcodes from CsoundAV by Gabriel Maldonado */
void    zread(void*), zaset(void*), zar(void*);
void    fastab_set(void *), fastabi(void *), fastabk(void *), fastab(void *);
void    fastabiw(void *), fastabkw(void *), fastabw(void *);
void    metro_set(void*), metro(void*), kdel_set(void*), kdelay(void*);
void    isChanged_set(void*), isChanged(void*);
void    mandel_set(void*), mandel(void*), vcella_set(void*), vcella(void*);
void    tab0(void*), tab1(void*), tab2(void*), tab3(void*), tab4(void*);
void    tab5(void*), tab6(void*), tab7(void*), tab8(void*), tab9(void*);
void    tab10(void*), tab11(void*), tab12(void*), tab13(void*);
void    tab14(void*), tab15(void*);
void    tab0_init(void*), tab1_init(void*), tab2_init(void*), tab3_init(void*);
void    tab4_init(void*), tab5_init(void*), tab6_init(void*), tab7_init(void*);
void    tab8_init(void*), tab9_init(void*), tab10_init(void*);
void    tab11_init(void*), tab12_init(void*), tab13_init(void*);
void    tab14_init(void*), tab15_init(void*);
void    partial_maximum_set(void*), partial_maximum(void*);

/* thread vals, where isub=1, ksub=2, asub=4:
                0 =     1  OR   2  (B out only)
                1 =     1
                2 =             2
                3 =     1  AND  2
                4 =                     4
                5 =     1  AND          4
                7 =     1  AND (2  OR   4)                      */

/* inarg types include the following:
                m       begins an indef list of iargs (any count)
                M       begins an indef list of args (any count and rate)   IV - Sep 1 2002
                n       begins an indef list of iargs (nargs odd)
                o       optional, defaulting to 0
                p          "            "       1
                q          "            "       10
                v          "            "       .5
                j          "            "       -1
                h          "            "       127
                y       begins indef list of aargs (any count)
                z       begins indef list of kargs (any count)
                Z       begins alternating kakaka...list (any count)
   outarg types include:
                m       multiple out aargs
                z               multiple out kargs
                X       multiple args (any rate)        IV - Sep 1 2002
   (these types must agree with rdorch.c)                       */

/* If dsblksize is 0xffff then translate */
/*                 0xfffe then translate two (oscil) */
/*                 0xfffd then translate two (peak) */
/*                 0xfffc then translate two (divz) */

OENTRY opcodlst_2[] = {
/* opcode   dspace      thread  outarg  inargs  isub    ksub    asub    */
{ "pinkish", S(PINKISH),  5,    "a",    "xoooo", pinkset, NULL, pinkish },
{ "noise",  S(VARI),   5,       "a",    "xk",   varicolset, NULL, varicol },
{ "inh",    S(INQ),     4,      "aaaaaa","",    NULL,   NULL,   inh     },
{ "ino",    S(INQ),     4,      "aaaaaaaa","",  NULL,   NULL,   ino     },
{ "inx",    S(INALL),   4,      "aaaaaaaaaaaaaaaa","",  NULL,   NULL,   in16 },
{ "in32",   S(INALL),   4,      "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
                                        "",     NULL,   NULL,   in32 },
{ "inch",   S(INALL),   4,      "a",    "k",    NULL,   NULL,   inall   },
{ "inz",    S(IOZ),     4,      "",     "k",    zaset,  NULL,   inz     },
  /* Note that there is code in rdorch.c that assumes that opcodes starting
     with the charcters out followed by a s, q, h, o or x are in this group
     ***BEWARE***
   */
{ "outh",   S(OUTH),    4,      "",     "aaaaaa",NULL,  NULL,   outh    },
{ "outo",   S(OUTO),    4,      "",     "aaaaaaaa",NULL,NULL,   outo    },
{ "outx",   S(OUTX),    4,      "",     "aaaaaaaaaaaaaaaa",NULL,NULL, outx },
{ "out32",  S(OUTX),    4,      "",     "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
                                                NULL,   NULL,   outX    },
{ "outch",  S(OUTCH),   4,      "",     "Z",    NULL,   NULL,   outch   },
{ "outc",   S(OUTX),    4,      "",     "y",    NULL,   NULL,   outall  },
{ "outz",   S(IOZ),     4,      "",     "k",    zaset,  NULL,   outz    },
{ "cpsxpch", S(XENH),   1,      "i",    "iiii", cpsxpch, NULL,  NULL    },
{ "cps2pch", S(XENH),   1,      "i",    "ii",   cps2pch, NULL,  NULL    },
{ "cpstun", S(CPSTUN),  2,      "k",    "kkk",   NULL,   cpstun         },
{ "cpstuni",S(CPSTUNI), 1,      "i",    "ii",   cpstun_i,               },
{ "nlfilt",  S(NLFILT), 5,      "a",    "akkkkk",nlfiltset, NULL, nlfilt},
{ "cross2",  S(CON),    5,      "a",    "aaiiik",Xsynthset, NULL, Xsynth},
{ "repluck", S(WGPLUCK2), 5,    "a",    "ikikka",wgpsetin,   NULL,     wgpluck},
{ "wgpluck2",S(WGPLUCK2), 5,    "a",    "ikikk", wgpset,     NULL,     wgpluck},
{ "wgclar",  S(CLARIN),  5,     "a",    "kkkiikkkio",clarinset,NULL,   clarin},
{ "wgflute", S(FLUTE),   5,     "a",    "kkkiikkkiovv",fluteset,NULL,  flute },
{ "wgbow",   S(BOWED),   5,     "a",    "kkkkkkio", bowedset, NULL,    bowed },
{ "wgbowedbar", S(BOWEDBAR), 5, "a",    "kkkkkoooo", bowedbarset, NULL, bowedbar },
{ "wgbrass", S(BRASS),   5,     "a",    "kkkikkio", brassset, NULL,     brass},
{ "marimba", S(MARIMBA), 5,     "a",    "kkiiikkiioo", marimbaset, NULL, marimba},
{ "vibes", S(VIBRAPHN),  5,     "a",    "kkiiikkii", vibraphnset,NULL,vibraphn},
{ "gogobel",S(VIBRAPHN), 5,     "a",    "kkiiikki", agogobelset,NULL, agogobel},
{ "shaker",  S(SHAKER),  5,     "a",    "kkkkko",  shakerset, NULL,   shaker},
{ "cabasa",  S(CABASA),  5,     "a",    "iiooo",    cabasaset, NULL,   cabasa},
{ "crunch",  S(CABASA),  5,     "a",    "iiooo",    crunchset, NULL,   cabasa},
{ "sekere",  S(SEKERE),  5,     "a",    "iiooo",    sekereset, NULL,   sekere},
{ "sandpaper", S(SEKERE),5,     "a",    "iiooo",    sandset, NULL,   sekere},
{ "stix", S(SEKERE),     5,     "a",    "iiooo",    stixset, NULL,   sekere},
{ "guiro", S(GUIRO),     5,     "a",    "kiooooo",   guiroset, NULL, guiro},
{ "tambourine", S(TAMBOURINE),5,"a",    "kioooooo", tambourset, NULL, tambourine},
{ "bamboo", S(BAMBOO),   5,     "a",    "kioooooo", bambooset, NULL, bamboo },
{ "dripwater", S(WUTER), 5,     "a",    "kioooooo", wuterset, NULL, wuter },
{ "sleighbells", S(SLEIGHBELLS), 5, "a","kioooooo", sleighset, NULL, sleighbells },
{ "fmbell",  S(FM4OP),   5,     "a",    "kkkkkkiiiii",tubebellset,NULL,tubebell},
{ "fmrhode", S(FM4OP),   5,     "a",    "kkkkkkiiiii",rhodeset,NULL,  tubebell},
{ "fmwurlie", S(FM4OP),  5,     "a",    "kkkkkkiiiii",wurleyset, NULL, wurley},
{ "fmmetal", S(FM4OP),   5,     "a",    "kkkkkkiiiii",heavymetset, NULL, heavymet},
{ "fmb3", S(FM4OP),      5,     "a",    "kkkkkkiiiii", b3set, NULL, hammondB3},
{ "fmvoice", S(FM4OPV),  5,     "a",    "kkkkkkiiiii",FMVoiceset, NULL, FMVoice},
{ "fmpercfl", S(FM4OP),  5,     "a",    "kkkkkkiiiii",percfluteset, NULL, percflute},
{ "moog", S(MOOG1),      5,     "a",    "kkkkkkiii", Moog1set, NULL, Moog1  },
{ "voice", S(VOICF),     5,     "a",    "kkkkkkii", voicformset, NULL, voicform},
{ "mandol", S(MANDOL),   5,     "a",    "kkkkkkio", mandolinset, NULL, mandolin},
{ "dcblock", S(DCBlocker),5,    "a",    "ao",   dcblockrset, NULL, dcblockr},
{ "flanger", S(FLANGER), 5,     "a",    "aakv", flanger_set, NULL, flanger },
{ "sum", S(SUM),         4,     "a",    "y",    NULL, NULL, sum            },
{ "product", S(SUM),     4,     "a",    "y",    NULL, NULL, product        },
{ "maca", S(SUM),        5,     "a",    "y",    macset,      NULL, maca    },
{ "mac", S(SUM),         5,     "a",    "Z",    macset,      NULL, mac     },
{ "active", 0xffff                                                         },
{ "active.i", S(INSTCNT),1,     "i",    "i",    instcount, NULL, NULL      },
{ "active.k", S(INSTCNT),2,     "k",    "k",    NULL, instcount, NULL      },
#if defined(CWIN) || defined(TCLTK)
{ "control", S(CNTRL),   3,     "k",    "k",    cntrl_set, control, NULL   },
{ "setctrl", S(SCNTRL),  1,     "",     "iSi",  ocontrol, NULL, NULL   },
{ "button", S(CNTRL),    3,     "k",    "k",    button_set, button, NULL   },
{ "checkbox", S(CNTRL),  3,     "k",    "k",    check_set, check,   NULL   },
{ "flashtxt", S(TXTWIN), 1,     "",     "iS",   textflash, NULL,    NULL   },
#endif
{ "adsr", S(LINSEG),     7,     "s",    "iiiio",adsrset,klnseg, linseg     },
{ "madsr", S(LINSEG),    7,     "s",    "iiiioj", madsrset,klnsegr, linsegr },
{ "xadsr", S(EXXPSEG),   7,     "s",    "iiiio", xdsrset, kxpseg, expseg    },
{ "mxadsr", S(EXPSEG),   7,     "s",    "iiiioj", mxdsrset, kxpsegr, expsegr },
{ "transeg", S(TRANSEG), 7,     "s",    "iiim", trnset, ktrnseg,    trnseg },
{ "schedule", S(SCHED),  1,     "",     "Siim", schedule, schedwatch, NULL },
{ "schedwhen", S(WSCHED),3,     "",     "kSkkm",ifschedule, kschedule, NULL },
{ "schedkwhen", S(TRIGINSTR), 3,"",     "kkkSkz",triginset, ktriginstr, NULL },
/* IV - Jan 02 2003: for compatibility */
{ "schedwhenname", S(WSCHED), 3, "",    "kSkkm",ifschedule, kschedule, NULL },
{ "schedkwhenname",S(TRIGINSTR), 3, "", "kkkSkz",triginset, ktriginstr, NULL },
{ "eventname", S(LINEVENT), 3,  "",     "SSz",  event_set, eventOpcode, NULL },
/* ----------------- */
{ "trigseq", S(TRIGSEQ), 3,     "",     "kkkkkz", trigseq_set, trigseq, NULL },
{ "seqtime", S(SEQTIM),  3,     "k",    "kkkkk", seqtim_set, seqtim, NULL   },
{ "event", S(LINEVENT),  3,     "",     "SSz",  event_set, eventOpcode, NULL },
{ "lfo", S(LFO),         7,     "s",    "kko",  lfoset,   lfok,   lfoa     },
{ "streson", S(STRES),   5,     "a",    "aki",  stresonset, NULL, streson  },
{ "pitch", S(PITCH),     5,    "kk", "aiiiiqooooojo", pitchset, NULL, pitch },
{ "clockon", S(CLOCK),   3,     "",     "i",    clockset, clockon, NULL    },
{ "clockoff", S(CLOCK),  3,     "",     "i",    clockset, clockoff, NULL   },
{ "readclock", S(CLKRD), 1,     "i",    "i",    clockread, NULL, NULL      },
{ "mpulse", S(IMPULSE),  5,     "a",    "kko",  impulse_set, NULL, impulse },
{ "pitchamdf",S(PITCHAMDF), 5,  "kk","aiioppoo", pitchamdfset, NULL, pitchamdf },
{ "scanu", S(PSCSNU),5, "", "iiiiiiikkkkiikkaii", scsnu_init, NULL, scsnu_play },
{ "scans", S(PSCSNS),    5,     "a",    "kkiio", scsns_init, NULL, scsns_play},
{ "xscanu", S(PSCSNUX),5, "", "iiiiSiikkkkiikkaii", scsnux_init, NULL, scsnux },
{ "xscans", S(PSCSNSX),  5,     "a",    "kkiio", scsnsx_init, NULL, scsnsx},
{ "xscanmap", S(PSCSNMAPX),3,   "kk",   "ikko",   scsnmapx_init, scsnmapx, NULL },
{ "xscansmap", S(PSCSNMAPX),3,   "",    "kkikko", scsnmapx_init, scsnsmapx, NULL },
{ "clip", S(CLIP),       5,     "a",    "aiiv", clip_set, NULL, clip        },
{ "vbap4",  S(VBAP_FOUR), 5, "aaaa","aioo", vbap_FOUR_init, NULL, vbap_FOUR },
{ "vbap8",  S(VBAP_EIGHT), 5, "aaaaaaaa","aioo", vbap_EIGHT_init, NULL, vbap_EIGHT },
{ "vbap16", S(VBAP_SIXTEEN), 5, "aaaaaaaaaaaaaaaa","aioo", vbap_SIXTEEN_init, NULL, vbap_SIXTEEN },
{ "vbapz",  S(VBAP_ZAK), 5,     "",    "iiaioo", vbap_zak_init, NULL, vbap_zak },
{ "vbaplsinit",  S(VBAP_LS_INIT), 1, "","iioooooooooooooooooooooooooooooooo", vbap_ls_init},
{ "vbap4move",  S(VBAP_FOUR_MOVING), 5, "aaaa","aiiim", vbap_FOUR_moving_init, NULL, vbap_FOUR_moving },
{ "vbap8move",  S(VBAP_EIGHT_MOVING), 5, "aaaaaaaa","aiiim", vbap_EIGHT_moving_init, NULL, vbap_EIGHT_moving },
{ "vbap16move",  S(VBAP_SIXTEEN_MOVING), 5, "aaaaaaaaaaaaaaaa","aiiim", vbap_SIXTEEN_moving_init, NULL, vbap_SIXTEEN_moving },
{ "vbapzmove",  S(VBAP_ZAK_MOVING), 5, "","iiaiiim", vbap_zak_moving_init, NULL, vbap_zak_moving },
{ "sense", S(KSENSE),    3,     "k",    "",      isense, ksense, NULL           },
{ "sensekey", S(KSENSE), 3,     "k",    "",      isense, ksense, NULL           },
{ "tempoval", S(GTEMPO), 2,     "k",    "",      NULL, gettempo, NULL           },
#ifdef BETA
{ "oscilv",  0xfffe                                                       },
{ "oscilv.kk", S(XOSC),  5,     "a",    "kkio", Foscset, NULL,   Fosckk   },
{ "oscilv.ka", S(XOSC),  5,     "a",    "kaio", Foscset, NULL,   Foscka   },
{ "oscilv.ak", S(XOSC),  5,     "a",    "akio", Foscset, NULL,   Foscak   },
{ "oscilv.aa", S(XOSC),  5,     "a",    "aaio", Foscset, NULL,   Foscaa   },
{ "pss", S(P_S),         1,     "",    "SS", p_s },
#endif
{ "reverb2",  S(NREV2),  5,     "a",    "akkoojoj", reverbx_set,NULL,reverbx    },
{ "nreverb",  S(NREV2),  5,     "a",    "akkoojoj", reverbx_set,NULL,reverbx    },
{ "babo",   S(BABO),     5,     "aa",   "akkkiiijj", baboset, NULL, babo        },
{ "lpf18", S(LPF18),     5,     "a",    "akkk",  lpf18set, NULL, lpf18db        },
{ "waveset", S(BARRI),   5,     "a",    "ako",   wavesetset,  NULL, waveset     },
{ "dconv",  S(DCONV),    5,     "a",    "aii",   dconvset, NULL, dconv          },
{ "vcomb", S(VCOMB),     5,     "a",    "akxioo", vcombset, NULL, vcomb         },
{ "valpass", S(VCOMB),   5,     "a",    "akxioo", vcombset, NULL, valpass       },
{ "ftmorf", S(FTMORF),   3,     "",     "kii",  ftmorfset,  ftmorf,     NULL    },
{ "p.i", S(PFUN),        1,     "i",    "i",     pfun, NULL, NULL               },
{ "p.k", S(PFUN),        2,     "k",    "k",     NULL, pfun, NULL               },
{ "bbcutm",S(BBCUTMONO), 5,     "a","aiiiiipop",BBCutMonoInit, NULL, BBCutMono  },
{ "bbcuts",S(BBCUTSTEREO),5,    "aa","aaiiiiipop",BBCutStereoInit, NULL, BBCutStereo},
{ "spat3d",   S(SPAT3D), 5,  "aaaa", "akkkiiiiio", spat3dset, NULL, spat3d      },
{ "spat3di",  S(SPAT3D), 5,  "aaaa", "aiiiiiio", spat3diset, NULL, spat3di      },
{ "spat3dt",  S(SPAT3D), 1,      "", "iiiiiiiio", spat3dt, NULL, NULL           },
{ "oscbnk",   S(OSCBNK), 5,     "a", "kkkkiikkkkikkkkkkikooooooo",
                                                 oscbnkset, NULL, oscbnk        },
{ "grain2",   S(GRAIN2), 5,     "a", "kkkikiooo", grain2set, NULL, grain2       },
{ "grain3",   S(GRAIN3), 5,     "a", "kkkkkkikikkoo", grain3set, NULL, grain3   },
{ "oscils",   S(OSCILS), 5,     "a", "iiio",     oscils_set, NULL, oscils       },
{ "lphasor",  S(LPHASOR),5,     "a", "xooooooo" ,lphasor_set, NULL, lphasor     },
{ "tablexkt", S(TABLEXKT),5,    "a", "xkkiooo",  tablexkt_set, NULL, tablexkt   },
{ "rnd31",    0xFFFF                                                            },
{ "rnd31.i",  S(RND31),  1,     "i", "iio",      rnd31i, NULL, NULL             },
{ "rnd31.k",  S(RND31),  3,     "k", "kko",      rnd31set, rnd31k, NULL         },
{ "rnd31.a",  S(RND31),  5,     "a", "kko",      rnd31set, NULL, rnd31a         },
/* IV - Aug 23 2002, IV - Sep 5 2002 */
{ "oscilikt", 0xFFFE                                                            },
{ "oscilikt.kk",S(OSCKT), 7,    "s", "kkkoo",    oscktset, kosclikt, osckkikt   },
{ "oscilikt.ka",S(OSCKT), 5,    "a", "kakoo",    oscktset, NULL,     osckaikt   },
{ "oscilikt.ak",S(OSCKT), 5,    "a", "akkoo",    oscktset, NULL,     oscakikt   },
{ "oscilikt.aa",S(OSCKT), 5,    "a", "aakoo",    oscktset, NULL,     oscaaikt   },
{ "osciliktp",  S(OSCKTP),5,    "a", "kkko",     oscktpset, NULL,    oscktp     },
{ "oscilikts",  S(OSCKTS),5,    "a", "xxkako",   oscktsset, NULL,    osckts     },
/* IV - Sep 25 2002 -- new opcodes: vco2init, vco2ft, vco2 */
{ "vco2init", S(VCO2INIT), 1,   "i", "ijjjjj",   vco2init, NULL, NULL           },
{ "vco2ift",    S(VCO2FT),1,    "i", "iov",      vco2ftset, NULL, NULL          },
{ "vco2ft",     S(VCO2FT),3,    "k", "kov",      vco2ftset, vco2ft, NULL        },
{ "vco2",       S(VCO2),  5,    "a", "kkoM",     vco2set, NULL, vco2            },
/* IV - Aug 23 2002 */
#if defined(HAVE_FLTK)
{ "FLslider",S(FLSLIDER), 1,    "ki",   "Siijjjjjjj", fl_slider, NULL, NULL   },
{ "FLslidBnk",S(FLSLIDERBANK), 1, "", "Siooooooooo", fl_slider_bank, NULL, NULL },
{ "FLknob",S(FLKNOB),     1,    "ki",   "Siijjjjjjo", fl_knob, NULL, NULL     },
{ "FLroller",S(FLROLLER), 1,    "ki",   "Siijjjjjjjj", fl_roller, NULL, NULL  },
{ "FLtext",S(FLTEXT),     1,    "ki",   "Siijjjjjj",  fl_text, NULL, NULL     },
{ "FLjoy",S(FLJOYSTICK),  1,    "kkii", "Siiiijjjjjjjj", fl_joystick, NULL, NULL},
{ "FLcount",S(FLCOUNTER), 1,    "ki",   "Siiiiiiiiiiz", fl_counter, NULL, NULL },
{ "FLbutton",S(FLBUTTON), 1,    "ki",   "Siiiiiiiz",  fl_button, NULL, NULL   },
{ "FLbutBank",S(FLBUTTONBANK), 1, "ki", "iiiiiiiiz", fl_button_bank, NULL, NULL },
{ "FLkeyb",S(FLKEYB),     1,    "k",    "z",     FLkeyb, NULL, NULL           },
{ "FLcolor",S(FLWIDGCOL), 1,    "",     "jjjjjj", fl_widget_color, NULL, NULL },
{ "FLcolor2",S(FLWIDGCOL2), 1,  "",     "jjj",   fl_widget_color2, NULL, NULL },
{ "FLlabel",S(FLWIDGLABEL), 1,  "",     "ojojjj", fl_widget_label, NULL, NULL },
{ "FLsetVal_i",S(FL_SET_WIDGET_VALUE_I), 1, "", "ii", fl_setWidgetValuei, NULL,
                                                      NULL                    },
{ "FLsetVal",S(FL_SET_WIDGET_VALUE), 3, "", "kki", fl_setWidgetValue_set,
                                                   fl_setWidgetValue, NULL    },
{ "FLsetColor",S(FL_SET_COLOR), 1, "",  "iiii",  fl_setColor1, NULL, NULL     },
{ "FLsetColor2",S(FL_SET_COLOR), 1, "", "iiii",  fl_setColor2, NULL, NULL     },
{ "FLsetTextSize",S(FL_SET_TEXTSIZE), 1, "", "ii", fl_setTextSize, NULL, NULL },
{ "FLsetTextColor",S(FL_SET_COLOR), 1, "", "iiii", fl_setTextColor, NULL, NULL },
{ "FLsetFont",S(FL_SET_FONT), 1, "",    "ii",    fl_setFont, NULL, NULL       },
{ "FLsetTextType",S(FL_SET_FONT), 1, "", "ii",   fl_setTextType, NULL, NULL   },
{ "FLsetText",S(FL_SET_TEXT), 1, "",    "Si",    fl_setText, NULL, NULL       },
{ "FLsetSize",S(FL_SET_SIZE), 1, "",    "iii",   fl_setSize, NULL, NULL       },
{ "FLsetPosition",S(FL_SET_POSITION), 1, "", "iii", fl_setPosition, NULL, NULL },
{ "FLhide",S(FL_WIDHIDE), 1,    "",     "i",     fl_hide, NULL, NULL          },
{ "FLshow",S(FL_WIDSHOW), 1,    "",     "i",     fl_show, NULL, NULL          },
{ "FLsetBox",S(FL_SETBOX), 1,   "",     "ii",    fl_setBox, NULL, NULL        },
{ "FLsetAlign",S(FL_TALIGN), 1, "",     "ii",    fl_align, NULL, NULL         },
{ "FLbox",S(FL_BOX),      1,    "i",    "Siiiiiii", fl_box, NULL, NULL        },
{ "FLvalue",S(FLVALUE),   1,    "i",    "Sjjjj", fl_value, NULL, NULL         },
{ "FLpanel",S(FLPANEL),   1,    "",     "Sjjooo", StartPanel, NULL, NULL      },
{ "FLpanel_end",S(FLPANELEND), 1, "",   "",      EndPanel, NULL, NULL         },
{ "FLpanelEnd",S(FLPANELEND), 1,  "",   "",      EndPanel, NULL, NULL         },
{ "FLscroll",S(FLSCROLL), 1,    "",     "iiii",  StartScroll, NULL, NULL      },
{ "FLscroll_end",S(FLSCROLLEND), 1, "", "",      EndScroll, NULL, NULL        },
{ "FLscrollEnd",S(FLSCROLLEND), 1, "",  "",      EndScroll, NULL, NULL        },
{ "FLpack",S(FLPACK),     1,    "",     "iiiiiiij", StartPack, NULL, NULL     },
{ "FLpack_end",S(FLPACKEND), 1, "",     "",      EndPack, NULL, NULL          },
{ "FLpackEnd",S(FLPACKEND), 1,  "",     "",      EndPack, NULL, NULL          },
{ "FLtabs",S(FLTABS),     1,    "",     "iiii",  StartTabs, NULL, NULL        },
{ "FLtabs_end",S(FLTABSEND), 1, "",     "",      EndTabs, NULL, NULL          },
{ "FLtabsEnd",S(FLTABSEND), 1,  "",     "",      EndTabs, NULL, NULL          },
{ "FLgroup",S(FLGROUP),   1,    "",     "Siiiij", StartGroup, NULL, NULL      },
{ "FLgroup_end",S(FLGROUPEND), 1, "",   "",      EndGroup, NULL, NULL         },
{ "FLgroupEnd",S(FLGROUPEND),  1, "",   "",      EndGroup, NULL, NULL         },
{ "FLsetsnap",S(FLSETSNAP), 1,  "ii",   "io",    set_snap, NULL, NULL         },
{ "FLgetsnap",S(FLGETSNAP), 1,  "i",    "i",     get_snap, NULL, NULL         },
{ "FLsavesnap",S(FLSAVESNAPS), 1, "",   "S",     save_snap, NULL, NULL        },
{ "FLloadsnap",S(FLLOADSNAPS), 1, "",   "S",     load_snap, NULL, NULL        },
{ "FLrun",S(FLRUN),       1,    "",     "",      FL_run, NULL, NULL           },
{ "FLupdate",S(FLRUN),    1,    "",     "",      fl_update, NULL, NULL        },
{ "FLprintk",S(FLPRINTK), 3,    "",     "iki",   FLprintkset, FLprintk, NULL  },
{ "FLprintk2",S(FLPRINTK2), 3,  "",     "ki",    FLprintk2set, FLprintk2, NULL },
#endif
{ "=.f",      S(FASSIGN), 2,    "f",   "f",      NULL, fassign, NULL          },
{ "pvsanal",  S(PVSANAL), 5,    "f",   "aiiiioo",  pvsanalset, NULL, pvsanal  },
{ "pvsynth",  S(PVSYNTH), 5,    "a",   "fo",     pvsynthset, NULL, pvsynth    },
{ "pvsadsyn", S(PVADS),   7,    "a",   "fikopo", pvadsynset, pvadsyn, pvadsyn },
{ "pvscross", S(PVSCROSS),3,    "f",   "ffkk",   pvscrosset, pvscross, NULL   },
{ "pvsfread", S(PVSFREAD),3,    "f",   "kSo",    pvsfreadset, pvsfread, NULL  },
{ "pvsmaska", S(PVSMASKA),3,    "f",   "fik",    pvsmaskaset, pvsmaska, NULL  },
{ "pvsftw",   S(PVSFTW),  3,    "k",   "fio",    pvsftwset, pvsftw, NULL      },
{ "pvsftr",   S(PVSFTR),  3,    "",    "fio",    pvsftrset, pvsftr, NULL      },
{ "pvsinfo",  S(PVSINFO), 1,    "iiii","f",      pvsinfo, NULL, NULL          },
{ "lineto",   S(LINETO),  3,    "k",   "kk",     lineto_set,   lineto, NULL   },
{ "tlineto",  S(LINETO2), 3,    "k",   "kkk",    tlineto_set,   tlineto, NULL },
{ "vibrato",  S(VIBRATO), 3,    "k", "kkkkkkkkio", vibrato_set, vibrato, NULL },
{ "vibr",     S(VIBRATO), 3,    "k",   "kki",    vibr_set, vibr, NULL         },
{ "jitter2",  S(JITTER2), 3,    "k",   "kkkkkkk", jitter2_set, jitter2, NULL  },
{ "jitter",   S(JITTER),  3,    "k",   "kkk",    jitter_set, jitter, NULL     },
{ "jspline",  S(JITTERS), 7,    "s",   "xkk",    jitters_set, jitters, jittersa },
{ "loopseg",  S(LOOPSEG), 3,    "k",   "kkz",    loopseg_set,   loopseg, NULL },
{ "lpshold",  S(LOOPSEG), 3,    "k",   "kkz",    loopseg_set,   lpshold, NULL },
{ "cuserrnd", 0xffff                                                          },
{ "duserrnd", 0xffff                                                          },
{ "random",   0xffff                                                          },
{ "cuserrnd.i", S(CURAND),1,    "i",    "iii",  iContinuousUserRand, NULL, NULL },
{ "cuserrnd.k", S(CURAND),2,    "k",  "kkk", Cuserrnd_set, kContinuousUserRand, NULL },
{ "cuserrnd.a", S(CURAND),4,    "a",  "kkk", Cuserrnd_set, NULL, aContinuousUserRand },
{ "random.i", S(RANGERAND), 1,  "i",    "ii",    ikRangeRand, NULL, NULL      },
{ "random.k", S(RANGERAND), 2,  "k",    "kk",    NULL, ikRangeRand, NULL      },
{ "random.a", S(RANGERAND), 4,  "a",    "kk",    NULL, NULL,  aRangeRand      },
{ "rspline",  S(RANDOM3), 7,    "s",    "xxkk",  random3_set, random3, random3a },
{ "randomi",  S(RANDOMI), 7,    "s",    "kkx",   randomi_set, krandomi, randomi },
{ "randomh",  S(RANDOMH), 7,    "s",    "kkx",   randomh_set, krandomh, randomh },
{ "urd.i",    S(DURAND),  1,    "i",    "i",     iDiscreteUserRand, NULL, NULL },
{ "urd.k",    S(DURAND),  2,    "k",    "k",  Cuserrnd_set, kDiscreteUserRand, NULL  },
{ "urd.a",    S(DURAND),  4,    "a",    "k",  Cuserrnd_set, NULL, aDiscreteUserRand  },
{ "duserrnd.i", S(DURAND),1,    "i",    "i",  iDiscreteUserRand, NULL, NULL  },
{ "duserrnd.k", S(DURAND),2,    "k",    "k",  Cuserrnd_set, kDiscreteUserRand, NULL  },
{ "duserrnd.a", S(DURAND),4,    "a",    "k",  Cuserrnd_set, NULL, aDiscreteUserRand  },
{ "octave",   0xffff                                                          },
{ "semitone", 0xffff                                                          },
{ "cent",     0xffff                                                          },
{ "octave.i", S(EVAL),    1,    "i",    "i",     ipowoftwo                    },
{ "octave.k", S(EVAL),    3,    "k",    "k",     powoftwo_set,   powoftwo     },
{ "octave.a", S(EVAL),    5,    "a",    "a",     powoftwo_set, NULL, powoftwoa },
{ "semitone.i",S(EVAL),   1,    "i",    "i",     isemitone                    },
{ "semitone.k",S(EVAL),   3,    "k",    "k",     powoftwo_set,   semitone     },
{ "semitone.a",S(EVAL),   5,    "a",    "a",     powoftwo_set, NULL, asemitone },
{ "cent.i",   S(EVAL),    1,    "i",    "i",     icent                        },
{ "cent.k",   S(EVAL),    3,    "k",    "k",     powoftwo_set,   cent         },
{ "cent.a",   S(EVAL),    5,    "a",    "a",     powoftwo_set, NULL, acent    },
{ "db",       0xffff                                                          },
{ "db.i",     S(EVAL),    1,    "i",    "i",     dbi                          },
{ "db.k",     S(EVAL),    3,    "k",    "k",     powoftwo_set, db             },
{ "db.a",     S(EVAL),    5,    "a",    "a",     powoftwo_set, NULL, dba      },
{ "and.ii",  S(AOP),    1,      "i",    "ii",   and_kk                  },
{ "and.kk",  S(AOP),    2,      "k",    "kk",   NULL,   and_kk          },
{ "and.ka",  S(AOP),    4,      "a",    "ka",   NULL,   NULL,   and_ka  },
{ "and.ak",  S(AOP),    4,      "a",    "ak",   NULL,   NULL,   and_ak  },
{ "and.aa",  S(AOP),    4,      "a",    "aa",   NULL,   NULL,   and_aa  },
{ "or.ii",   S(AOP),    1,      "i",    "ii",   or_kk                   },
{ "or.kk",   S(AOP),    1,      "i",    "kk",   or_kk                   },
{ "or.ka",   S(AOP),    4,      "a",    "ka",   NULL,   or_kk,          },
{ "or.ak",   S(AOP),    4,      "a",    "ak",   NULL,   NULL,   or_ak   },
{ "or.aa",   S(AOP),    4,      "a",    "aa",   NULL,   NULL,   or_aa   },
{ "xor.ii",  S(AOP),    1,      "i",    "ii",   xor_kk                  },
{ "xor.kk",  S(AOP),    2,      "k",    "kk",   NULL,   xor_kk          },
{ "xor.ka",  S(AOP),    4,      "a",    "ka",   NULL,   NULL,   xor_ka  },
{ "xor.ak",  S(AOP),    4,      "a",    "ak",   NULL,   NULL,   xor_ak  },
{ "xor.aa",  S(AOP),    4,      "a",    "aa",   NULL,   NULL,   xor_aa  },
{ "not.i",   S(AOP),    1,      "i",    "i",    not_k                   },
{ "not.k",   S(AOP),    2,      "k",    "k",    NULL,   not_k           },
{ "not.a",   S(AOP),    4,      "a",    "a",    NULL,   NULL,   not_a   },
{ "midichn",  S(MIDICHN), 1,    "i",    "",     midichn, NULL, NULL     },
{ "pgmassign",S(PGMASSIGN), 1,   "",    "iS",   pgmassign, NULL, NULL   },
{ "midinoteoff", S(MIDINOTEON),3,"",    "xx",   midinoteoff, midinoteoff, },
{ "midinoteonkey", S(MIDINOTEON),3, "", "xx",   midinoteonkey, midinoteonkey },
{ "midinoteoncps", S(MIDINOTEON), 3, "", "xx",  midinoteoncps,midinoteoncps },
{ "midinoteonoct", S(MIDINOTEON), 3, "", "xx",  midinoteonoct,midinoteonoct },
{ "midinoteonpch", S(MIDINOTEON), 3, "", "xx",  midinoteonpch, midinoteonpch },
{ "midipolyaftertouch", S(MIDIPOLYAFTERTOUCH),
                   3,   "", "xxoh", midipolyaftertouch, midipolyaftertouch},
{ "midicontrolchange", S(MIDICONTROLCHANGE),
                   3, "", "xxoh",midicontrolchange, midicontrolchange   },
{ "midiprogramchange", S(MIDIPROGRAMCHANGE),
                   3, "", "x", midiprogramchange, midiprogramchange     },
{ "midichannelaftertouch", S(MIDICHANNELAFTERTOUCH),
                   3, "", "xoh",midichannelaftertouch, midichannelaftertouch },
{ "midipitchbend", S(MIDIPITCHBEND),3, "", "xoh", midipitchbend, midipitchbend },
{ "mididefault", S(MIDIDEFAULT), 3, "", "xx",   mididefault, mididefault },
{ "wterrain", S(WAVETER), 5,    "a",    "kkkkkkii", wtinit, NULL, wtPerf },
{ "scantable", S(SCANTABLE), 5, "a",    "kkiiiii", scantinit, NULL, scantPerf },
{ "scanhammer", S(SCANHAMMER), 1,"",    "iiii", scanhinit, NULL, NULL   },
{ "clfilt", S(CLFILT),  5,      "a",    "akiioppo",clfiltset, NULL, clfilt },
{ "invalue", S(INVAL),     3,   "k",    "S", invalset, kinval, NULL      },
{ "outvalue", S(OUTVAL), 3,     "",     "Sk", outvalset, koutval, NULL   },
/* IV - Oct 20 2002 */
{ ".subins", S(SUBINST), 5,  "mmmmmmmm", "m",   subins2_set, NULL, subinstr },
{ "subinstr", S(SUBINST), 5, "mmmmmmmm", "Sm",  subinstrset, NULL, subinstr },
{ "subinstrinit", S(SUBINST), 1, "",    "Sm",   subinstrinitset, NULL, NULL },
{ "nstrnum", S(NSTRNUM), 1,     "i",    "S",    nstrnumset, NULL, NULL   },
{ "cngoto", S(CGOTO),   3,      "",     "Bl",   ingoto, kngoto, NULL     },
/* IV - Sep 8 2002 - added entries for user defined opcodes, xin, xout */
/* and setksmps */
{ ".userOpcode", S(UOPCODE), 7, "", "", useropcdset, useropcd, useropcd  },
/* IV - Oct 24 2002: the length of the outypes string for xin must be */
/* OPCODENUMOUTS characters (required by padout code in instance(). */
{ "xin", S(XIN),   1, "XXXXXXXXXXXXXXXXXXXXXXXX", "", xinset, NULL, NULL },
{ "xout", S(XOUT),    1,        "",     "M",    xoutset, NULL, NULL      },
{ "setksmps", S(SETKSMPS), 1,   "",     "i",    setksmpsset, NULL, NULL  },
{ "ftsave",S(FTLOAD), 1,        "",     "Sim", ftsave                    },
{ "ftload",S(FTLOAD), 1,        "",     "Sim", ftload                    },
{ "ftsavek",S(FTLOAD_K), 3,    "",      "Skim", ftsave_k_set, ftsave_k   },
{ "ftloadk",S(FTLOAD_K), 3,    "",      "Skim", ftsave_k_set, ftload_k   },
{ "mute", S(MUTE), 1,          "",      "So",   mute_inst                },
/* IV - Dec 20 2002: new arithmetic opcodes */
{ "Add", 0xFFFC                                                         },
{ "Sub", 0xFFFC                                                         },
{ "Mul", 0xFFFC                                                         },
{ "Div", 0xFFFC                                                         },
{ "sub", 0xFFFC                                                         },
{ "mul", 0xFFFC                                                         },
{ "div", 0xFFFC                                                         },
{ "Add.ii",   S(AOP),   1,      "i",    "ii",   addkk                   },
{ "Sub.ii",   S(AOP),   1,      "i",    "ii",   subkk                   },
{ "Mul.ii",   S(AOP),   1,      "i",    "ii",   mulkk                   },
{ "Div.ii",   S(AOP),   1,      "i",    "ii",   divkk                   },
{ "Add.kk",   S(AOP),   2,      "k",    "kk",   NULL,   addkk           },
{ "Sub.kk",   S(AOP),   2,      "k",    "kk",   NULL,   subkk           },
{ "Mul.kk",   S(AOP),   2,      "k",    "kk",   NULL,   mulkk           },
{ "Div.kk",   S(AOP),   2,      "k",    "kk",   NULL,   divkk           },
{ "Add.ka",   S(AOP),   4,      "a",    "ka",   NULL,   NULL,   addka   },
{ "Sub.ka",   S(AOP),   4,      "a",    "ka",   NULL,   NULL,   subka   },
{ "Mul.ka",   S(AOP),   4,      "a",    "ka",   NULL,   NULL,   mulka   },
{ "Div.ka",   S(AOP),   4,      "a",    "ka",   NULL,   NULL,   divka   },
{ "Add.ak",   S(AOP),   4,      "a",    "ak",   NULL,   NULL,   addak   },
{ "Sub.ak",   S(AOP),   4,      "a",    "ak",   NULL,   NULL,   subak   },
{ "Mul.ak",   S(AOP),   4,      "a",    "ak",   NULL,   NULL,   mulak   },
{ "Div.ak",   S(AOP),   4,      "a",    "ak",   NULL,   NULL,   divak   },
{ "Add.aa",   S(AOP),   4,      "a",    "aa",   NULL,   NULL,   addaa   },
{ "Sub.aa",   S(AOP),   4,      "a",    "aa",   NULL,   NULL,   subaa   },
{ "Mul.aa",   S(AOP),   4,      "a",    "aa",   NULL,   NULL,   mulaa   },
{ "Div.aa",   S(AOP),   4,      "a",    "aa",   NULL,   NULL,   divaa   },
{ "vincr", 0xFFBE                                                       },
{ "vdecr", 0xFFBE                                                       },
{ "vmul", 0xFFBE                                                        },
{ "vdiv", 0xFFBE                                                        },
{ "vincr.ii", S(AOP),   1,      "",     "ii",   vincr_kk, NULL, NULL    },
{ "vincr.kk", S(AOP),   2,      "",     "kk",   NULL, vincr_kk, NULL    },
{ "vincr.ka", S(AOP),   2,      "",     "ka",   NULL, vincr_ka, NULL    },
{ "vincr.ak", S(AOP),   4,      "",     "ak",   NULL, NULL, vincr_ak    },
{ "vincr.aa", S(AOP),   4,      "",     "aa",   NULL, NULL, vincr_aa    },
{ "vdecr.ii", S(AOP),   1,      "",     "ii",   vdecr_kk, NULL, NULL    },
{ "vdecr.kk", S(AOP),   2,      "",     "kk",   NULL, vdecr_kk, NULL    },
{ "vdecr.ka", S(AOP),   2,      "",     "ka",   NULL, vdecr_ka, NULL    },
{ "vdecr.ak", S(AOP),   4,      "",     "ak",   NULL, NULL, vdecr_ak    },
{ "vdecr.aa", S(AOP),   4,      "",     "aa",   NULL, NULL, vdecr_aa    },
{ "vmul.ii",  S(AOP),   1,      "",     "ii",   vmul_kk, NULL, NULL     },
{ "vmul.kk",  S(AOP),   2,      "",     "kk",   NULL, vmul_kk, NULL     },
{ "vmul.ka",  S(AOP),   2,      "",     "ka",   NULL, vmul_ka, NULL     },
{ "vmul.ak",  S(AOP),   4,      "",     "ak",   NULL, NULL, vmul_ak     },
{ "vmul.aa",  S(AOP),   4,      "",     "aa",   NULL, NULL, vmul_aa     },
{ "vdiv.ii",  S(AOP),   1,      "",     "ii",   vdiv_kk, NULL, NULL     },
{ "vdiv.kk",  S(AOP),   2,      "",     "kk",   NULL, vdiv_kk, NULL     },
{ "vdiv.ka",  S(AOP),   2,      "",     "ka",   NULL, vdiv_ka, NULL     },
{ "vdiv.ak",  S(AOP),   4,      "",     "ak",   NULL, NULL, vdiv_ak     },
{ "vdiv.aa",  S(AOP),   4,      "",     "aa",   NULL, NULL, vdiv_aa     },
{ "Inc", 0xFFBF                                                         },
{ "Dec", 0xFFBF                                                         },
{ "dec", 0xFFBF                                                         },
{ "shl", 0xFFBF                                                         },
{ "sqr", 0xFFBF                                                         },
{ "Inc.i",    S(AOP),   1,      "",     "i",    inc_k, NULL, NULL       },
{ "Inc.k",    S(AOP),   2,      "",     "k",    NULL, inc_k, NULL       },
{ "Inc.a",    S(AOP),   4,      "",     "a",    NULL, NULL, inc_a       },
{ "Dec.i",    S(AOP),   1,      "",     "i",    dec_k, NULL, NULL       },
{ "Dec.k",    S(AOP),   2,      "",     "k",    NULL, dec_k, NULL       },
{ "Dec.a",    S(AOP),   4,      "",     "a",    NULL, NULL, dec_a       },
{ "dec.i",    S(AOP),   1,      "",     "i",    dec_k, NULL, NULL       },
{ "dec.k",    S(AOP),   2,      "",     "k",    NULL, dec_k, NULL       },
{ "dec.a",    S(AOP),   4,      "",     "a",    NULL, NULL, dec_a       },
{ "shl.i",    S(AOP),   1,      "",     "i",    shl_k, NULL, NULL       },
{ "shl.k",    S(AOP),   2,      "",     "k",    NULL, shl_k, NULL       },
{ "shl.a",    S(AOP),   4,      "",     "a",    NULL, NULL, shl_a       },
{ "sqr.i",    S(AOP),   1,      "",     "i",    sqr_k, NULL, NULL       },
{ "sqr.k",    S(AOP),   2,      "",     "k",    NULL, sqr_k, NULL       },
{ "sqr.a",    S(AOP),   4,      "",     "a",    NULL, NULL, sqr_a       },
/* -------------------------------------------------------------------- */
{ "denorm",   S(DENORMS),   4,  "",     "y",    NULL, NULL, denorms         },
{ "delayk",   S(DELAYK),    3,  "k",    "kio",  delaykset, delayk, NULL     },
{ "vdel_k",   S(VDELAYK),   3,  "k",    "kkio", vdelaykset, vdelayk, NULL   },
{ "rbjeq",    S(RBJEQ),     5,  "a",    "akkkko", rbjeqset, NULL, rbjeq     },
/* IV - Dec 28 2002: end of new opcodes */
{ "sprintks", S(SPRINTKS),  3,  "",     "SiM",  sprintksset, sprintks, NULL },
{ "prints",   S(PRINTS),    1,  "",     "SM",   printsset, NULL, NULL       },
{ "fprints",  S(FPRINTF),   1,  "",     "SSM",  fprintf_i, NULL, NULL       },
{ "fprintks", S(FPRINTF),   3,  "",     "SSM",  fprintf_set, fprintf_k, NULL },
/* -- IV - Jan 02 2003: new opcodes from CsoundAV (by Gabriel Maldonado) -- */
{ "tab_i",  S(FASTAB),    1,    "i",    "iio",      fastabi, NULL, NULL      },
{ "tab",    0xFFFF                                                           },
{ "tab.i",  S(FASTAB),    1,    "i",    "iio",      fastabi, NULL, NULL      },
{ "tab.k",  S(FASTAB),    3,    "k",    "kio",     fastab_set, fastabk, NULL },
{ "tab.a",  S(FASTAB),    5,    "a",    "aio",      fastab_set, NULL, fastab },
{ "tabw_i",  S(FASTAB),   1,    "",     "iiio",     fastabiw, NULL, NULL     },
{ "tabw",   0xFFFC                                                           },
{ "tabw.ii", S(FASTAB),   1,    "",     "iiio",     fastabiw, NULL, NULL     },
{ "tabw.kk", S(FASTAB),   3,    "",     "kkio",   fastab_set, fastabkw, NULL },
{ "tabw.aa", S(FASTAB),   5,    "",     "aaio",    fastab_set, NULL, fastabw },
{ "metro",  S(METRO),     3,    "k",    "ko",       metro_set, metro, NULL   },
{ "vdelayk",S(KDEL),      3,    "k",    "kkioo",    kdel_set, kdelay, NULL   },
{ "mandel", S(MANDEL),    3,    "kk",   "kkkk",     mandel_set, mandel, NULL },
{ "vcella", S(CELLA),     3,    "",     "kkiiiiip", vcella_set, vcella, NULL },
{ "zr.i",   S(ZKR),       1,    "i",    "i",        zread, NULL, NULL        },
{ "zr.k",   S(ZKR),       2,    "k",    "k",        NULL, zread, NULL        },
{ "zr.a",   S(ZAR),       5,    "a",    "a",        zaset, NULL, zar         },
/* ------------------------------------------------------------------------- */
{ "tb0_init", S(TB_INIT), 1,    "",     "i",        tab0_init, NULL, NULL    },
{ "tb1_init", S(TB_INIT), 1,    "",     "i",        tab1_init, NULL, NULL    },
{ "tb2_init", S(TB_INIT), 1,    "",     "i",        tab2_init, NULL, NULL    },
{ "tb3_init", S(TB_INIT), 1,    "",     "i",        tab3_init, NULL, NULL    },
{ "tb4_init", S(TB_INIT), 1,    "",     "i",        tab4_init, NULL, NULL    },
{ "tb5_init", S(TB_INIT), 1,    "",     "i",        tab5_init, NULL, NULL    },
{ "tb6_init", S(TB_INIT), 1,    "",     "i",        tab6_init, NULL, NULL    },
{ "tb7_init", S(TB_INIT), 1,    "",     "i",        tab7_init, NULL, NULL    },
{ "tb8_init", S(TB_INIT), 1,    "",     "i",        tab8_init, NULL, NULL    },
{ "tb9_init", S(TB_INIT), 1,    "",     "i",        tab9_init, NULL, NULL    },
{ "tb10_init", S(TB_INIT), 1,   "",     "i",        tab10_init, NULL, NULL   },
{ "tb11_init", S(TB_INIT), 1,   "",     "i",        tab11_init, NULL, NULL   },
{ "tb12_init", S(TB_INIT), 1,   "",     "i",        tab12_init, NULL, NULL   },
{ "tb13_init", S(TB_INIT), 1,   "",     "i",        tab13_init, NULL, NULL   },
{ "tb14_init", S(TB_INIT), 1,   "",     "i",        tab14_init, NULL, NULL   },
{ "tb15_init", S(TB_INIT), 1,   "",     "i",        tab15_init, NULL, NULL   },
/* ------------------------------------------------------------------------- */
{ "tb0.k",  S(FASTB),     2,    "k",    "k",        NULL, tab0, NULL         },
{ "tb1.k",  S(FASTB),     2,    "k",    "k",        NULL, tab1, NULL         },
{ "tb2.k",  S(FASTB),     2,    "k",    "k",        NULL, tab2, NULL         },
{ "tb3.k",  S(FASTB),     2,    "k",    "k",        NULL, tab3, NULL         },
{ "tb4.k",  S(FASTB),     2,    "k",    "k",        NULL, tab4, NULL         },
{ "tb5.k",  S(FASTB),     2,    "k",    "k",        NULL, tab5, NULL         },
{ "tb6.k",  S(FASTB),     2,    "k",    "k",        NULL, tab6, NULL         },
{ "tb7.k",  S(FASTB),     2,    "k",    "k",        NULL, tab7, NULL         },
{ "tb8.k",  S(FASTB),     2,    "k",    "k",        NULL, tab8, NULL         },
{ "tb9.k",  S(FASTB),     2,    "k",    "k",        NULL, tab9, NULL         },
{ "tb10.k", S(FASTB),     2,    "k",    "k",        NULL, tab10, NULL        },
{ "tb11.k", S(FASTB),     2,    "k",    "k",        NULL, tab11, NULL        },
{ "tb12.k", S(FASTB),     2,    "k",    "k",        NULL, tab12, NULL        },
{ "tb13.k", S(FASTB),     2,    "k",    "k",        NULL, tab13, NULL        },
{ "tb14.k", S(FASTB),     2,    "k",    "k",        NULL, tab14, NULL        },
{ "tb15.k", S(FASTB),     2,    "k",    "k",        NULL, tab15, NULL        },
/* ------------------------------------------------------------------------- */
{ "tb0.i",  S(FASTB),     1,    "i",    "i",        tab0, NULL, NULL         },
{ "tb1.i",  S(FASTB),     1,    "i",    "i",        tab1, NULL, NULL         },
{ "tb2.i",  S(FASTB),     1,    "i",    "i",        tab2, NULL, NULL         },
{ "tb3.i",  S(FASTB),     1,    "i",    "i",        tab3, NULL, NULL         },
{ "tb4.i",  S(FASTB),     1,    "i",    "i",        tab4, NULL, NULL         },
{ "tb5.i",  S(FASTB),     1,    "i",    "i",        tab5, NULL, NULL         },
{ "tb6.i",  S(FASTB),     1,    "i",    "i",        tab6, NULL, NULL         },
{ "tb7.i",  S(FASTB),     1,    "i",    "i",        tab7, NULL, NULL         },
{ "tb8.i",  S(FASTB),     1,    "i",    "i",        tab8, NULL, NULL         },
{ "tb9.i",  S(FASTB),     1,    "i",    "i",        tab9, NULL, NULL         },
{ "tb10.i", S(FASTB),     1,    "i",    "i",        tab10, NULL, NULL        },
{ "tb11.i", S(FASTB),     1,    "i",    "i",        tab11, NULL, NULL        },
{ "tb12.i", S(FASTB),     1,    "i",    "i",        tab12, NULL, NULL        },
{ "tb13.i", S(FASTB),     1,    "i",    "i",        tab13, NULL, NULL        },
{ "tb14.i", S(FASTB),     1,    "i",    "i",        tab14, NULL, NULL        },
{ "tb15.i", S(FASTB),     1,    "i",    "i",        tab15, NULL, NULL        },
/* ------------------------------------------------------------------------- */
{ "changed",S(ISCHANGED), 3,    "k",    "z",  isChanged_set, isChanged, NULL },
{ "max_k",  S(P_MAXIMUM), 5,    "k",    "ako",      partial_maximum_set,
                                                    NULL, partial_maximum    }
};

long oplength_2 = sizeof(opcodlst_2);

